#!/usr/bin/perl
require 'mainlibrary.pl';
#=========================================================================
#Filename: changeadminpassword.cgi
#Written By: Trevor Barnett
#File Description:
#  A form to change the administrator verification password used in account 
#  creation.  The script originally displays a form that contains the 
#  following password fields: old password, new password, and retype new 
#  password.  Once this form is submitted, the script connects to the 
#  database using DBI.  Then the script queries the database to see if the 
#  existing administrator verification password matches the old password 
#  field from the form.  If the two are equal, then the script checks to 
#  make sure that the new password and retype of the new password are equal.
#  If they are, then the script changes the administrator verification 
#  password to the new password using an update query.  A Password 
#  successfully changed screen is printed, the database connection is 
#  closed, and the script exits.
#=========================================================================
use CGI;  #Common Gateway Interface
use DBI;  #Perl DataBase Interface  
my $line; #contains a line of html code from administrator webpage template
my $name="mostwise"; #name of account that has the verification password
my $type="administrator"; #type of account is administrator
my $id=$administratorid; #id of account with verification password
my $q=new CGI; #CGI variable
my $usertype; #will be retrieved from database for verification
my $userid; #will be retrieved from database for verification
my $oldpassword = $q->param('oldpassword'); #old password from CGI
my $newpassword = $q->param('newpassword'); #new password from CGI
my $retypepassword = $q -> param('retypepassword'); #retype the password from CGI
my $databaseanswer; #retrieved from the database

my $database = $dbname; #name of the database 
my $port = $dbport; #mysql database port
my $dsn = $dbpassword; #database password file location

#connect to the database or exit
my $dbh = DBI->connect($dsn)
   or exit(1);

#Query to find userid
my $sth = $dbh->prepare ("SELECT userid FROM users WHERE username = '$name' AND password=PASSWORD('$oldpassword')");
$sth->execute();
$userid= $sth->fetchrow_array();
$sth->finish();

#Query to find usertype
$sth = $dbh->prepare ("SELECT usertype FROM users WHERE username = '$name' AND password=PASSWORD('$oldpassword')");
$sth->execute();
$usertype = $sth->fetchrow_array();
$sth->finish();

#print content in html
print "Content-type:text/html\n\n";

#open administrator webpage template
open(ADMINPAGE, "administrator.html");
while($line=<ADMINPAGE>){
  if($line eq "<!--MAIN--!>\n"){
    #if predefined variables match database information then change password and print success page
    if(($newpassword eq $retypepassword)&&($userid eq $id)&&($newpassword)&&($usertype eq $type)){
      $sth = $dbh->prepare("UPDATE users  SET password = PASSWORD('$newpassword') WHERE userid='$userid'");
      $sth->execute();
      $sth->finish();
      print<<RESETPASSWORD;
        <p align="center"><font size="5" color="#FFFFFF">Password Changed</font><font size="4"><p align="center">
        </div><center>
        Administrator verification password has been successfully changed.</center></font>
RESETPASSWORD
    }
    else{
      #variables do not match, print an error page
      print<<ERROR;
        <p>
        <center><font style="font-size: 16pt" color="#FF3300" face="Arial Black">Error!</font></center><br>
        <div align="center">
        <center>
        <table border="0" cellpadding="2" style="border-collapse: collapse" bordercolor="#111111" width="60%">
        <tr>
        <td width="100%"><font size="4">Passwords do not match.  Please use the <a href="javascript: history.go(-1)" >Back</a> button and try again.</font></td>
        </tr>
        </table>
        </center>
        </div>
ERROR
      }
    }
print "$line"; #print a line of the administrator webpage template
}
close ADMINPAGE; #close administrator page
$dbh->disconnect(); #disconnect from the database
exit(0); #exit the program

