#!/usr/bin/perl
require 'mainlibrary.pl';
#=========================================================================
#Filename: login.cgi
#Written By: Trevor Barnett
#File Description:
#  Accepts a username and password as input from the CGI.  The script
#  queries the database and checks to see if the username and password
#  match an entry in the database.  If the username and password are valid,
#  the script performs an additional query to find out the users type 
#  (teacher, administrator, or student).  The script then prints the content
#  of the webpage template that corresponds to the users type.  This
#  transition provides the user with access to more restricted scripts and
#  files that cannot be accessed before logging in.  Finally, the script sets
#  a cookie that contains the username, user type, and user id.  This cookie
#  tracks the user as he or she navigates through different pages on the
#  website.  When the user closes the browser or logs out, the browser
#  deletes this cookie.  
#=========================================================================
use DBI;
use CGI;
require 'cookielib/cookie.lib';
my $line;
my $q=new CGI;
my $username = $q->param('username');
my $password = $q->param('password');
my $name;
my $userid;
my $usertype;
my $database = $dbname;
my $port = $dbport;
my $dsn = $dbpassword;

my $dbh = DBI->connect($dsn)
   or exit(1);

my $sth = $dbh->prepare ("SELECT username FROM users WHERE username = '$username' AND password=PASSWORD('$password')");
$sth->execute();
$name = $sth->fetchrow_array();
$sth->finish();

$sth = $dbh->prepare ("SELECT userid FROM users WHERE username = '$name' AND password=PASSWORD('$password')");
$sth->execute();
$userid= $sth->fetchrow_array();
$sth->finish();

$sth = $dbh->prepare ("SELECT usertype FROM users WHERE username = '$name' AND password=PASSWORD('$password')");
$sth->execute();
$usertype = $sth->fetchrow_array();
$sth->finish();


if(($name)&&($usertype eq "student")&&($userid)) {
  #user has been authenticated, allow them to enter
  print "Content-type:text/html\n";
  &SetCookies('name', "$name", 'userid', "$userid", 'usertype', "$usertype");
  print "\n";
  open(STUDENT, "student.html");
  while($line=<STUDENT>){
    print "$line";
    if($line eq "<!--MAIN--!>\n"){
       print<<STUDENT;
STUDENT
    }
  }
  close(STUDENT);
}
elsif(($name)&&($usertype eq "teacher")&&($userid)) {
  #user has been authenticated, allow them to enter
  print "Content-type:text/html\n";
  &SetCookies('name', "$name", 'userid', "$userid", 'usertype', "$usertype");
  print "\n";
  open(TEACHER, "teacher.html");
  while($line=<TEACHER>){
    print "$line";
    if($line eq "<!--MAIN--!>\n"){
       print<<TEACHER;
TEACHER
    }
  }
  close(TEACHER);
}
elsif(($name)&&($usertype eq "administrator")&&($userid)) {
  #user has been authenticated, allow them to enter
  print "Content-type:text/html\n";
  &SetCookies('name', "$name", 'userid', "$userid", 'usertype', "$usertype");
  print "\n";
  open(ADMINISTRATOR, "administrator.html");
  while($line=<ADMINISTRATOR>){
    print "$line";
    if($line eq "<!--MAIN--!>\n"){
       print<<ADMINISTRATOR;
ADMINISTRATOR
    }
  }
  close(ADMINISTRATOR);
}
else {
    #user's password was not correct, give them an error page
    print "Content-type:text/html\n\n";
    open(HOME, "home.html");
    while($line=<HOME>){
      print "$line";
      if($line eq "<!--MAIN--!>\n"){
        print<<ERROR;
<p align="center"><font style="font-size: 18pt" color="#FF0000">
                Authentication Error!</font></p>
                <p align="center"><font style="font-size: 14pt" color="#000000">Username/Password is 
                invalid or does not exist.</font>
ERROR
      }
    }
    close(HOME);
}

$dbh->disconnect();
exit(0);

