#!/usr/bin/perl
require 'mainlibrary.pl';
#=========================================================================
#Filename: registeraccount.cgi
#Written By: Trevor Barnett
#File Description:
#  Contains the following fields: username, password, retype password, email
#  address, secret question, secret answer, user type, and verification
#  password.  When the form is submitted, the script first uses Perl DBI
#  (Database Interface) to connect to the database.  The database is queried
#  to see if any other users have already taken the username and also to make
#  sure that the verification password is correct for the usertype.  If the
#  database checks are passed, the script then compares the password and the
#  retyped password to make sure that they are equal.  If they are the same,
#  then the script starts the process of creating an account for the user.
#  The script inserts a new entry into the users table with the form 
#  information received from CGI.  Then the script uses sendmail to send an
#  email to the user with the account information used to create the account.
#  Finally the script prints a success page in the common webpage template
#  and exits.
#=========================================================================
use DBI;
use CGI;
my $line;
my $q=new CGI;
my $username = $q->param('username');
my $password = $q->param('password');
my $retypepassword = $q->param('retypepassword');
my $emailaddress = $q -> param('emailaddress');
my $secretquestion = $q -> param('SecretQuestion');
my $secretanswer = $q -> param('secretanswer');
my $usertype = $q -> param('usertype');
my $verifypassword = $q -> param('verifypassword');
my $secretquestionnumber;
my @secretquestionarray = ("Favorite pet's name?", "Favorite movie?", "Favorite book?", "Mother's maiden name?", "Father's middle name?", "Spouse's middle name?", "First child's middle name?", "High school mascot?", "Favorite teacher's name", "Favorite sports team?");
my $i;
my $userid;
my $tempusername;

my $database = $dbname;
my $port = $dbport;
my $dsn = $dbpassword;

my $dbh = DBI->connect($dsn)
   or exit(1);

print "Content-type:text/html\n\n";


for $i (0 .. 10) {
  if($secretquestionarray[$i] eq $secretquestion){
    $secretquestionnumber = $i + 1;
  }
}

my $sth = $dbh->prepare("Select username FROM users WHERE username='$username'");
$sth->execute();
$tempusername=$sth->fetchrow_array();
$sth->finish();
if($username eq $tempusername){
  &PrintError;
}
elsif (!$username || !$password || !$retypepassword || !$emailaddress || !$secretanswer || !$ verifypassword){
  &PrintError;
}
elsif($password ne $retypepassword) {
  &PrintError;
}
elsif($usertype eq "Student"){
  #get student userid, then check to see if it is right
  $sth = $dbh->prepare ("SELECT userid FROM users WHERE username='student' AND password=PASSWORD('$verifypassword')");
  $sth->execute();
  $userid = $sth->fetchrow_array();
  $sth->finish();
  if($userid eq $studentid){
    $sth = $dbh->prepare("INSERT INTO users VALUES('$username', PASSWORD('$password'), '$emailaddress', '$secretquestionnumber', '$secretanswer', 'student', '')");
    $sth->execute();
    $sth->finish();
    &PrintSuccess;
  }
  else{&PrintError;}
}
elsif($usertype eq "Teacher"){
  #get teacher userid, then check to see if it is right
  $sth = $dbh->prepare ("SELECT userid FROM users WHERE username='teacher' AND password=PASSWORD('$verifypassword')");
  $sth->execute();
  $userid = $sth->fetchrow_array();
  $sth->finish();
  if($userid eq $teacherid){
    $sth = $dbh->prepare("INSERT INTO users VALUES('$username', PASSWORD('$password'), '$emailaddress', '$secretquestionnumber', '$secretanswer', 'teacher', '')");
    $sth->execute();
    $sth->finish();
    &PrintSuccess;
  }
  else{&PrintError;}
}
elsif($usertype eq "Administrator"){
  #get administrator userid then check to see if it is right
  $sth = $dbh->prepare ("SELECT userid FROM users WHERE username='mostwise' AND password=PASSWORD('$verifypassword')");
  $sth->execute();
  $userid = $sth->fetchrow_array();
  $sth->finish();
  if($userid eq $administratorid){
    $sth = $dbh->prepare("INSERT INTO users VALUES('$username', PASSWORD('$password'), '$emailaddress', '$secretquestionnumber', '$secretanswer', 'administrator', '')");
    $sth->execute();
    $sth->finish();
    &PrintSuccess;
  }
  else{&PrintError;}
}
else{
  &PrintError;
}

sub PrintError {
open(MAINPAGE, "home.html");
while($line=<MAINPAGE>){
  print "$line";
  if($line eq "<!--MAIN--!>\n"){
print <<ERROR;
<div align="center">
  <center>
  <table border="0" cellspacing="1" style="border-collapse: collapse" bordercolor="#111111" width="70%" height="116">
    <tr>
      <td width="100%" align="center" height="62">
<p align="center"><font size="5" color="#FF0000">ERROR!</font></p>
      </td>
    </tr>
    <tr>
      <td width="100%" align="center" height="48">
    <p align="left">
<font style="font-size: 16pt">Your account could not be created.&nbsp;
ERROR
if (!$username || !$password || !$retypepassword || !$emailaddress || !$secretanswer || !$ verifypassword){
  print "You did not complete all the required fields.";
}
elsif($password ne $retypepassword){
  print "Passwords do not match.";
}
elsif($username eq $tempusername){
  print "Username is already taken.";
}
else{
  print "Verification password was not correct.";
}
print "</font></td></tr></table></center></div>";}
}
}

sub PrintSuccess {
#send email message
open(MAIL, "| /usr/sbin/sendmail -oi -n -t");
print MAIL <<MAIL_MESSAGE;
To:$emailaddress
From:MostWise\@MostWise.com
Subject: Registration Confirmation at MostWise.com
You have successfully registered for a $usertype account at MostWise.com
Below is some information that you should save or print for future reference:

Username: $username
Password: $password
Secret Question: $secretquestion
Secret Answer: $secretanswer
User type: $usertype

Thank you for using MostWise.com,
Admin

MAIL_MESSAGE
close MAIL;


open(MAINPAGE, "home.html");
while($line=<MAINPAGE>){
  print "$line";
  if($line eq "<!--MAIN--!>\n"){

print <<SUCCESS;
<div align="center">
  <center>
  <table border="0" cellspacing="1" style="border-collapse: collapse" bordercolor="#111111" width="70%" height="125">
    <tr>
      <td width="100%" align="center" height="71">
<p align="center"><font size="5" color="#FFFFFF">Success!</font></p>
      </td>
    </tr>
    <tr>
      <td width="100%" align="center" height="48">
    <p align="left">
<font style="font-size: 16pt">Your account has been successfully created and you will receive a confirmation email.
</font></td>
    </tr>
  </table>
  </center>
</div>
SUCCESS
}
}
}
#$dbh->disconnect();
exit(0);

