#!/usr/bin/perl
require 'mainlibrary.pl';
#=========================================================================
#Filename: student.cgi
#Written By: Trevor Barnett
#File Description:
#  Accepts a page name as its only input from CGI.  The script first checks
#  the browsers cookie to make sure that the user is a student and has
#  authorization to display the input page.  If the user is legitimate,
#  the script opens the student webpage template and prints the contents of
#  this file until it finds the invisible comment used to mark the starting
#  point of the main webpage area.  When this comment is reached, the script
#  prints the html in the main area, based on the page name the script
#  receives from the form submission.  After the script prints the main area
#  html, it resumes printing the remaining content of the webpage template
#  html file.  Finally, the script closes the student.html file and exits.
#  This script is simple but critical to the operation of MostWise.  It is
#  responsible for printing the html that transports the user around the
#  website.  
#=========================================================================
use strict;
use CGI;
my $line;
my $q=new CGI;
my $page = $q->param('page');

print "Content-type:text/html\n\n";

if($page eq "mainmenu"){
  open(MAINMENU, "mainmenu.html");
  while($line=<MAINMENU>){
    print "$line\n";
  }
  close(MAINMENU);
}
else{
open(STUDENTPAGE, "student.html");
while($line=<STUDENTPAGE>){
  if($page eq "logout"){
    $line =~ s/BODY/Body onLoad="begintimer()"/;
  }
  if($line eq "<!--MAIN--!>\n"){
      if($page eq "quizzes"){
       print <<QUIZZES;
QUIZZES
      }
	elsif($page eq "glossary"){
	 print <<GLOSSARY;
<form name="glossarybrowseA" method=post action="glossary.cgi">
<input type=hidden name="letter" value="a">
</FORM>
<form name="glossarybrowseB" method=post action="glossary.cgi">
<input type=hidden name="letter" value="b">
</FORM>
<form name="glossarybrowseC" method=post action="glossary.cgi">
<input type=hidden name="letter" value="c">
</FORM>
<form name="glossarybrowseD" method=post action="glossary.cgi">
<input type=hidden name="letter" value="d">
</FORM>
<form name="glossarybrowseE" method=post action="glossary.cgi">
<input type=hidden name="letter" value="e">
</FORM>
<form name="glossarybrowseF" method=post action="glossary.cgi">
<input type=hidden name="letter" value="f">
</FORM>
<form name="glossarybrowseG" method=post action="glossary.cgi">
<input type=hidden name="letter" value="g">
</FORM>
<form name="glossarybrowseH" method=post action="glossary.cgi">
<input type=hidden name="letter" value="h">
</FORM>
<form name="glossarybrowseI" method=post action="glossary.cgi">
<input type=hidden name="letter" value="i">
</FORM>
<form name="glossarybrowseJ" method=post action="glossary.cgi">
<input type=hidden name="letter" value="j">
</FORM>
<form name="glossarybrowseK" method=post action="glossary.cgi">
<input type=hidden name="letter" value="k">
</FORM>
<form name="glossarybrowseL" method=post action="glossary.cgi">
<input type=hidden name="letter" value="l">
</FORM>
<form name="glossarybrowseM" method=post action="glossary.cgi">
<input type=hidden name="letter" value="m">
</FORM>
<form name="glossarybrowseN" method=post action="glossary.cgi">
<input type=hidden name="letter" value="n">
</FORM>
<form name="glossarybrowseO" method=post action="glossary.cgi">
<input type=hidden name="letter" value="o">
</FORM>
<form name="glossarybrowseP" method=post action="glossary.cgi">
<input type=hidden name="letter" value="p">
</FORM>
<form name="glossarybrowseQ" method=post action="glossary.cgi">
<input type=hidden name="letter" value="q">
</FORM>
<form name="glossarybrowseR" method=post action="glossary.cgi">
<input type=hidden name="letter" value="r">
</FORM>
<form name="glossarybrowseS" method=post action="glossary.cgi">
<input type=hidden name="letter" value="s">
</FORM>
<form name="glossarybrowseT" method=post action="glossary.cgi">
<input type=hidden name="letter" value="t">
</FORM>
<form name="glossarybrowseU" method=post action="glossary.cgi">
<input type=hidden name="letter" value="u">
</FORM>
<form name="glossarybrowseV" method=post action="glossary.cgi">
<input type=hidden name="letter" value="v">
</FORM>
<form name="glossarybrowseW" method=post action="glossary.cgi">
<input type=hidden name="letter" value="w">
</FORM>
<form name="glossarybrowseX" method=post action="glossary.cgi">
<input type=hidden name="letter" value="x">
</FORM>
<form name="glossarybrowseY" method=post action="glossary.cgi">
<input type=hidden name="letter" value="y">
</FORM>
<form name="glossarybrowseZ" method=post action="glossary.cgi">
<input type=hidden name="letter" value="z">
</FORM>

<p align="center">
<font color="#FFFFFF" size="5">
                <b>Glossary</b></font><b></div></b><br><p>
                <div align="center">
  <center>
  <table border="0" cellspacing="5" style="border-collapse: collapse" bordercolor="#111111" width="80%" cellpadding="5">
    <tr>
      <td width="50%">
      <p align="center"><b><font size="4">Search by keyword:</font></b></td>
      <td width="50%">
      <p align="center"><b><font size="4">Browse by first letter:</font></b></td>
    </tr>
    <tr>
      <form method=post name="glossaryhit" action="glossary.cgi">
      <td width="50%">
      <p align="center"><input type=text name="searchword" size="20"></td>
      <td width="50%" align="center"><a href="Javascript:document.glossarybrowseA.submit()">
      <font color="#000080">A</font></a><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseB.submit()">
      <font color="#000080">B</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseC.submit()">
      <font color="#000080">C</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseD.submit()">
      <font color="#000080">D</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseE.submit()">
      <font color="#000080">E</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseF.submit()">
      <font color="#000080">F</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseG.submit()">
      <font color="#000080">G</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseH.submit()">
      <font color="#000080">H</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseI.submit()">
      <font color="#000080">I</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseJ.submit()">
      <font color="#000080">J</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseK.submit()">
      <font color="#000080">K</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseL.submit()">
      <font color="#000080">L</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseM.submit()">
      <font color="#000080">M</font></A></td>
    </tr>
    <tr>
      <td width="50%">
      <p align="center"><b><input type=submit name="searchsubmit" value="Search" style="width: 75; height: 22; font-size: 15px"></b></td>
      </FORM>
      <td width="50%" align="center"><a href="Javascript:document.glossarybrowseN.submit()">
      <font color="#000080">N</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseO.submit()">
      <font color="#000080">O</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseP.submit()">
      <font color="#000080">P</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseQ.submit()">
      <font color="#000080">Q</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseR.submit()">
      <font color="#000080">R</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseS.submit()">
      <font color="#000080">S</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseT.submit()">
      <font color="#000080">T</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseU.submit()">
      <font color="#000080">U</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseV.submit()">
      <font color="#000080">V</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseW.submit()">
      <font color="#000080">W</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseX.submit()">
      <font color="#000080">X</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseY.submit()">
      <font color="#000080">Y</font></A><font color="#000080"> </font> <a href="Javascript:document.glossarybrowseZ.submit()">
      <font color="#000080">Z</font></A></td>
      
    </tr>
  </table>
  </center>
GLOSSARY
	}
	elsif($page eq "help"){
	 print <<HELP;
HELP
	}
	elsif($page eq "logout"){
print <<LOGOUT;
<center>
&nbsp;<p><font size="4">Attempting to log you out </font>
<img border="0" src="../images/19anidot1c.gif">
<img border="0" src="../images/19anidot1c.gif">
<img border="0" src="../images/19anidot1c.gif">
<img border="0" src="../images/19anidot1c.gif"></p>
<p>&nbsp;</p></center>
<script>
var limit="0:3"
if (document.images){
var parselimit=limit.split(":")
parselimit=parselimit[0]*60+parselimit[1]*1
}
function begintimer(){
if (!document.images)
return
if (parselimit==1) {
window.open("http://$URL/logout.html", target="_top")
}
else{ 
parselimit-=1
curmin=Math.floor(parselimit/60)
cursec=parselimit%60
if (curmin!=0)
curtime=curmin+" minutes and "+cursec+" seconds left"
else
curtime=cursec+" seconds left"
window.status=curtime
setTimeout("begintimer()",1000)
}
}
</script>
LOGOUT
	}
	elsif($page eq "viewprogress"){
	 print <<VIEWPROGRESS;
VIEWPROGRESS
	}
      elsif($page eq "changepassword"){
      print <<CHANGEPASSWORD;
<form method=post action="changepassword.cgi">
<p align="center"><b><font style="font-size: 16pt" color="#FFFFFF">Change 
Password</font></b></p>
<div align="center">
  <center>
  <table border="0" cellspacing="1" style="border-collapse: collapse" bordercolor="#111111" width="70%">
    <tr>
      <td width="50%" align="right">Old Password:</td>
      <td width="50%">&nbsp;<input type=password name="oldpassword" size="20"></td>
    </tr>
    <tr>
      <td width="50%" align="right">New Password:</td>
      <td width="50%">&nbsp;<input type=password name="newpassword" size="20"></td>
    </tr>
    <tr>
      <td width="50%" align="right">Retype New Password:</td>
      <td width="50%">&nbsp;<input type=password name="retypepassword" size="20"></td>
    </tr>
  </table>
  <p>
  <input type=submit name=submit value="Change Password">
  </FORM>
  </center>
</div>
<p align="center">
<br></p>
CHANGEPASSWORD
}
  } # end of if line eq <!--main--!>
print "$line";
} # end of while loop

close MAINPAGE;
}

exit(0);
